unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    procedure FormCreate(Sender: TObject);
    procedure Shape1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Shape2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Shape1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Shape1.Top  := Shape1.Top  - Shape1.Height div 2 + Y ;
  Shape1.Left := Shape1.Left - Shape1.Width  div 2 + X ;
end;

procedure TForm1.Shape2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Shape2.Top  := Shape2.Top  - Shape2.Height div 2 + Y ;
  Shape2.Left := Shape2.Left - Shape2.Width  div 2 + X ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // la prima shape ha uno Z-order inferiore (il triangolo và sotto al rettangolo) ma si può invertire
  Shape1.DragMode := dmAutomatic;
  Shape2.DragMode := dmAutomatic;
end;

end.

